#include <SoftwareSerial.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <SPI.h>
#include <RFID.h>

#define SS_PIN 10
#define RST_PIN 9

SoftwareSerial BTserial(5, 6);
LiquidCrystal_I2C lcd(0x27, 16, 2);
RFID rfid(SS_PIN, RST_PIN);
String rfidCard;

int flag = 0;
int led = 8;
int pir = 2;
int buzzer = 4;

int value = 0;
int res = 0;
int on = 0;
int pirState = LOW;

void setup()
{
  
  Serial.begin(9600);
  BTserial.begin(9600);
  Serial.println("Starting the RFID Reader...");
  SPI.begin();
  rfid.init(); 
  pinMode(led, OUTPUT);
  pinMode(pir, INPUT);
  pinMode(buzzer, OUTPUT);
  
	lcd.begin();
	lcd.backlight();

}

void loop()
{
  if (rfid.isCard()) {
    if (rfid.readCardSerial()) {
      rfidCard = String(rfid.serNum[0]) + " " + String(rfid.serNum[1]) + " " + String(rfid.serNum[2]) + " " + String(rfid.serNum[3]);
      Serial.println(rfidCard);
      if (rfidCard == "236 160 66 73") {
        res = 1;
        if (on == 0) {
        lcd.clear();
        lcd.print("Alarm");
        lcd.setCursor (0,1);
        lcd.print("is on!!");

        digitalWrite(led, HIGH);
        delay(200);
        digitalWrite(led, LOW);
        delay(200);
        digitalWrite(led, HIGH);
        delay(200);
        digitalWrite(led, LOW);
        delay(200);
        digitalWrite(led, HIGH);
        delay(200);
        digitalWrite(led, LOW);
        delay(200);
        on = 1;
        }
      } else if (rfidCard == "179 245 48 25" && on == 1) {
        res = 0;
        on = 0;
        lcd.clear();
        lcd.print("Alarm");
        lcd.setCursor (0,1);
        lcd.print("is off!!");
        delay(100);
        BTserial.println("Alarm is off! Bye bye");
      }
    }
    rfid.halt();
  }

  if (res == 1) {
  value = digitalRead(pir);

  if (value == HIGH) {
    digitalWrite(led, HIGH);

    if (pirState == LOW) {
      lcd.clear();
      lcd.print("Motion");
      lcd.setCursor (0,1);
      lcd.print("Detected!!");
      delay(100);
      
      tone(buzzer, 400, 1000);
      BTserial.println("Motion detected! PROBLEM PROBLEM \n");
      
      pirState = HIGH;
    }
  } else {
    digitalWrite(led, LOW);

    if(pirState == HIGH){
      lcd.clear();
      lcd.print("Motion");
      lcd.setCursor (0,1);
      lcd.print("Ended!!");
      noTone(buzzer);
      delay(100);
      BTserial.println("Your place is safe now ^_^ \n");
      pirState = LOW;
      }
    }
  } 
}
